/**
 * @file Fonctions et classes de cache
 * @author hadi
 * @namespace cache
 */


export class Cache<A, K> {
    /**
     * @memberof cache
     * @class Cache
     * @summary Permet le caching d'une classe A référencée par des keys K
     */


    instances = new Map<K, A>();
    aConstructor: (k: K) => A;


    constructor(aConstructor: (k: K) => A) {
        this.aConstructor = aConstructor;
    }

    async get(k: K){
        if (this.instances.has(k))
            return this.instances.get(k);
        else {
            const a = this.aConstructor(k);
            this.instances.set(k, a);
            return a;
        }
    }
}

